<?php

	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *        
	* JINZORA | Web-based Media Streamer   
	*
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a CMS site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL.
	* 
	* Jinzora Author:
	* Ross Carlson: ross@jasbone.com 
	* http://www.jinzora.org
	* Documentation: http://www.jinzora.org/docs	
	* Support: http://www.jinzora.org/forum
	* Downloads: http://www.jinzora.org/downloads
	* License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* Contributors:
	* Please see http://www.jinzora.org/modules.php?op=modload&name=jz_whois&file=index
	*
	* Code Purpose: Header for the default frontend.
	* Created: 10/3/04 by Ben Dodson
	*
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	require_once($include_path. 'frontend/class.php');
	require_once($include_path. 'frontend/blocks.php');
    require_once($include_path. 'frontend/frontends/msnmusic/blocks.php');		

	class jzFrontend extends jzFrontendClass {
		function pageTop($title = false, $endBreak = "true", $ratingItem = ""){
			global $this_page, $root_dir, $site_title, $node, $jzUSER, $jinzora_skin, $include_path, $album_name_truncate;
			
			// First let's include the settings for the frontend
			include_once($include_path. "frontend/frontends/msnmusic/settings.php");
			
			// Let's see if they wanted to pass a title
			if (!$title) { $title = $site_title; }			
			if (!isset($_GET['jz_path'])){$_GET['jz_path']="";}
										
			// Let's setup our objects
			$display = &new jzDisplay();
			$blocks = new jzBlocks();
			
			// First let's see if our session vars are set for the number of items
			if (!isset($_SESSION['jz_num_genres'])){
				$root = &new jzMediaNode();
				$_SESSION['jz_num_genres'] = $root->getSubNodeCount("nodes",distanceTo("genre"));
				$_SESSION['jz_num_artists'] = $root->getSubNodeCount("nodes",distanceTo("artist"));
				$_SESSION['jz_num_albums'] = $root->getSubNodeCount("nodes",distanceTo("album"));
				$_SESSION['jz_num_tracks'] = $root->getSubNodeCount("tracks",-1);
			}
			
			?>
			<table width="100%" align="center" border="0" cellpadding="0" cellspacing="0">
				<tr>
					<td width="100%">
						<table width="100%" align="center" border="0" cellpadding="10">
							<tr>
								<td width="20%">&nbsp;</td>
								<td width="60%">
									<img src="<?php echo $root_dir. '/style/'. $jinzora_skin. '/powered-by-small.gif'; ?>" border="0">
								</td>
								<td width="20%">&nbsp;</td>
							</tr>
						</table>
						<table width="100%" align="center" border="0" cellpadding="5" cellspacing="0">
							<tr>
								<td style="background-color: #B4CCEB" width="20%">&nbsp;</td>
								<td style="background-color: #B4CCEB" width="30%" nowrap>
									<?php
										// Can this user powersearch?
										if ($jzUSER->getSetting('powersearch')){
									?>
									<form action="<?php echo $this_page  ?>" method="POST">
										<input onMouseDown="value='';" type="text" name="search_query" class="jz_input" style="width:250px; font-size:10px" value="<?php echo word("music search"); ?>">
										<input type="submit" class="jz_submit" name="doSearch" value="Go">
									</form>
									<?php
										}
									?>
								</td>
								<td style="background-color: #B4CCEB" width="30%" align="right">
									<?php $display->loginLink("Login","Logout"); ?>
								</td>
								<td style="background-color: #B4CCEB" width="20%">&nbsp;</td>
							</tr>
						</table>
						
						
						
						
						
						

					</td>
				</tr>
			</table>
			
			<?php	
		}
		
		
		
		function footer($node=false){
			global $jinzora_url, $this_pgm, $version, $root_dir, $jinzora_skin, $show_jinzora_footer, 
			$show_page_load_time, $allow_interface_choice, $allow_style_choice, $jzUSER, $jzSERVICES; 
			
			// This setups the display object
			// This is really just a grouping of functions
			// for display related stuff like links and images
			$display = &new jzDisplay();
			
			// First let's make sure they didn't turn the footer off
			if ($show_jinzora_footer){
				?>
					<br>
					<table width="100%" align="center" border="0" cellpadding="0" cellspacing="0">
						<tr>
							<td width="100%">
								<table width="100%" align="center" border="0" cellpadding="5" cellspacing="0">
									<tr>
										<td style="background-color: #B4CCEB" width="20%">&nbsp;</td>
										<td style="background-color: #B4CCEB" width="30%">
											<?php
												if ($allow_interface_choice == "true"){
												  $display->InterfaceDropdown();
												}
												if ($allow_style_choice == "true"){
												  echo '&nbsp;';
												  $display->styleDropdown();
												}
											?>
										</td>
										<td style="background-color: #B4CCEB" width="30%" align="right">
											<?php
												if ($show_page_load_time == "true"){
													// Ok, let's get the difference
													$diff = round(microtime_diff($_SESSION['jz_load_time'],microtime()),3);
													echo '<span class="jz_artistDesc">';
													echo word("Page generated in"). ": ". $diff. " ". word("seconds");
													echo "</span>";
													echo "&nbsp;";
												}
												if ($jzUSER->getSetting("admin") == true && $node !== false) {
													$display->mediaManagementDropdown($node);
													echo "&nbsp;";
													$display->systemToolsDropdown($node);
													echo "&nbsp;";
												}
											?>
										</td>
										<td style="background-color: #B4CCEB" width="20%">&nbsp;</td>
									</tr>
								</table>
							</td>
						</tr>
					</table>
					<br><br>
				<?php
			}
			
			$jzSERVICES->cmsClose();
		}
		
		
		
		function jzFrontend() {
			parent::_constructor();
		}
		// use all of the default functions.
	}
?>