<?php
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *    
	* JINZORA | Web-based Media Streamer  
	*
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a CMS site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL. 
	* 
	* Jinzora Author:
	* Ross Carlson: ross@jasbone.com 
	* http://www.jinzora.org
	* Documentation: http://www.jinzora.org/docs	
	* Support: http://www.jinzora.org/forum
	* Downloads: http://www.jinzora.org/downloads
	* License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* Contributors:
	* Please see http://www.jinzora.org/modules.php?op=modload&name=jz_whois&file=index
	*
	* Code Purpose: This page contains all the album related related functions
	* Created: 9.24.03 by Ross Carlson
	*
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

 	// This function displays all the Genres or Artists 
	function drawPage(&$node){
		global $media_dir, $jinzora_skin, $hierarchy, $album_name_truncate, $row_colors, 
		       $img_download, $img_more, $img_email, $img_play, $img_random_play, $img_rate, $img_discuss, 
			   $num_other_albums, $root_dir, $enable_ratings, $short_date, $jzUSER, $img_play_dis, $img_random_play_dis,
			   $img_download_dis, $show_similar, $show_radio, $jzSERVICES, $show_album_art;					
							
		// Let's setup the new display object
		$display = &new jzDisplay();
		$blocks = &new jzBlocks();
		$fe = &new jzFrontend();
		$parent = $node->getAncestor("artist");
		if ($parent === false) {
		  $parent = new jzMediaNode();
		}

		// Now let's setup our buttons for later
		$playButtons = $display->playLink($node,$img_play,false,false,true). $display->playLink($node,$img_random_play,false,false,true,true);
		// Now let's make sure they can stream
		if (!$jzUSER->getSetting('stream')){
			$playButtons = $img_play_dis. $img_random_play_dis;
		}
		if ($jzUSER->getSetting('download')){
			$playButtons .= $display->downloadButton($node, false, true, true);
		} else {
			$playButtons .= $display->downloadButton($node, true, true, true);
		}

		if ($enable_ratings == "true"){
			$playButtons .= $display->rateButton($node, true);		
		}
		$playButtons .= " &nbsp; ";
		$playArtistButtons = $display->playLink($parent,$img_play,false,false,true). $display->playLink($parent,$img_random_play,false,false,true,true);
		if (!$jzUSER->getSetting('stream')){
			$playArtistButtons = $img_play_dis. $img_random_play_dis;
		}
		if ($enable_ratings == "true"){
			$playArtistButtons .= $display->rateButton($parent, true);		
		}
		$playArtistButtons .= " &nbsp; ";
		
		
		
		// Now let's setup the row with the description and the art for the album
		?>
		<table width="100%" cellpadding="5">
			<tr>
				<?php
					$year = $node->getYear();
					$dispYear = "";
					if ($year <> "-"){
						$dispYear = " (". $year. ")";
					}
					$title = returnItemShortName($node->getName(),$album_name_truncate);
					// Should we show the profiles?
					if ($show_album_art <> "false"){
						// Now let's make sure we have something to show
						$artSize = 100;$desc_truncate = 700;
						$desc = $node->getDescription();
						if ($desc == ""){
							$artSize = 200;
						}
						
						// Now do we have anything to show?
						$parentArt = $parent->getMainArt("150x150");
						$art = $node->getMainArt($artSize."x".$artSize);
						if (($parentArt <> false) 
							or ($parent->getDescription() <> "")
							or ($art <> false)
							or ($desc <> "")							
							) {
							echo '<td valign="top" width="10%" valign="top">';
							if ($art <> false) {
								$blocks->blockHeader(word("Profile"). ": ". $title. $dispYear. " &nbsp; ",$playButtons);
								$blocks->blockBodyOpen();
								?>
								<table width="100%" cellpadding="2" cellspacing="0" border="0">
									<tr>
										<td width="100%" <?php if ($desc == ""){ echo 'align="center"'; $align = "";} else { $align = "left";} ?>>
											<?php
												// If there is no description let's make the art bigger
												$rating = $display->rating($node,true);
												if ($rating <> ""){
													echo $rating. "<br>";
												}
												
												if ($jzUSER->getSetting('stream')) {
													$display->playLink($node,$display->returnImage($art,$node->getName(),$artSize,$artSize,"fit",false,false,$align,"5","5"));
												} else {
													$display->Image($art,$node->getName(),$artSize,$artSize,"fit",false,false,$align,"5","5");
												}
												if ($cms_mode == "false"){
													echo '<span class="jz_artistDesc">';
												}
												echo $display->returnShortName($desc,$desc_truncate);
												if (strlen($desc) > $desc_truncate){
													$url_array = array();
													$url_array['jz_path'] = $node->getPath("String");
													$url_array['action'] = "popup";
													$url_array['ptype'] = "readmore";
													echo ' <a href="'. urlize($url_array). '" onclick="openPopup(this, 450, 450); return false;">...read more</a>';
												}
												if ($node->getDateAdded() <> "0"){
													echo "<br>". word("Added"). ": ". date($short_date,$node->getDateAdded());
												}
												if ($cms_mode == "false"){
													echo '</span>';	
												}
											?>
										</td>
									</tr>
								</table>
								<?php
								$blocks->blockBodyClose();	
								$blocks->blockSpacer();
							}
							// Now should we show this one?
							if ($parentArt <> false or $parent->getDescription() <> "") {
								$blocks->blockHeader(word("Profile"). ": ". $parent->getName(). " ". $display->rating($parent,true). " &nbsp; ",$playArtistButtons);
								$blocks->blockBodyOpen();
							?>
							<table width="100%" cellpadding="2" cellspacing="0" border="0">
								<tr>
									<td width="100%">
										<?php								
											// Now let's get the art and description
											if ($parentArt !== false) {
											  $display->link($parent,$display->returnImage($parentArt,$parent->getName(),150,150,"limit",false,false,"left","5","5"));
											}
											if ($cms_mode == "false"){
									            echo '<span class="jz_artistDesc">';
											}
											$desc = $parent->getDescription();
											echo $display->returnShortName($desc,$desc_truncate);
											if (strlen($desc) > $desc_truncate){
												$url_array = array();
												$url_array['jz_path'] = $parent->getPath("String");
												$url_array['action'] = "popup";
												$url_array['ptype'] = "readmore";
												echo ' <a href="'. urlize($url_array). '" onclick="openPopup(this, 450, 450); return false;">...read more</a>';
											}
											if ($cms_mode == "false"){
												echo '</span>';
											}
										?>
									</td>
								</tr>
							</table>
						<?php
						$blocks->blockBodyClose();	
						}
					}
				}
			?>
			<td width="80%" valign="top">
				<?php
					$blocks->blockHeader("Tracks: ". $title. $dispYear, $playButtons);
					$blocks->blockBodyOpen();
				?>
				<table width="100%" cellpadding="2" cellspacing="0" border="0">
					<tr>
						<td width="100%" align="left">
							<?php
								// Now let's see if this is a multi-disc album
								$disks = $node->getSubNodes("nodes");
								if (count($disks) > 0){
									// Yep, it's a multi...
									$first = true;
									foreach ($disks as $disk) {
										$disktracks = $disk->getSubNodes("tracks",-1);
										sortElements($disktracks,"number");
										// Now let's display the album name
										if (!$first){echo "<br>";}
										$display->playButton($disk);
										$display->link($disk,"&nbsp;<strong>". $disk->getName()."</strong><br>");
										// Now let's display the tracks for this album
										$blocks->trackTable($disktracks, "album");
										$first=false;
									}
								}
								// Now let's read all the tracks for this album
								$tracks = $node->getSubNodes("tracks");
								sortElements($tracks,"number");
								$blocks->trackTable($tracks, "album");
							?>
						</td>
					</tr>
				</table>
				<?php
					$blocks->blockBodyClose();	

					// Now let's get some other random images
					if ($num_other_albums > 0) {
						$parent = $node->getNaturalParent(); 
						$nodes = $parent->getSubNodes("nodes",false,true,$num_other_albums * 2,true); // randomized, only with art.
						if (count($nodes) > 1 and $show_album_art <> "false"){							
							$blocks->blockSpacer();
							$blocks->blockHeader(word("Other Albums from"). " ". $parent->getName());
							$blocks->blockBodyOpen();
							?>
							<table width="100%" cellpadding="2" cellspacing="0" border="0">
								<tr>
									<td width="100%" align="center">
										<table width="100%">
											<tr>
											<?php
												// Now let's get some other random images											
												$ctr=0;
												foreach ($nodes as $child) {
													if ($child->getName() <> $node->getName()){	
														$year = $child->getYear();
														if ($year <> "-"){ $dispYear = " (". $year. ")"; } else { $dispYear = ""; }
														echo '<td align="center"><center>';
														$display->link($child,returnItemShortName($child->getName(),$album_name_truncate));
														echo "<br>";
														$display->link($child,$display->returnImage($child->getMainArt("100x100"),$child->getName(),100,false,"fit"), $child->getName() . $dispYear);
														echo "<br>";
														if ($jzUSER->getSetting('stream')){
															$display->playLink($child,word("Play"), word("Play"), "");
															echo " - ";
															$display->playLink($child,word("Play Random"), word("Play Random"), "",false,true);
														}														
														echo '</center></td>';
														$ctr++;
													}
													if ($ctr == $num_other_albums){break;}
												}
											?>
											</tr>
										</table>
									</td>
								</tr>
							</table>
						<?php
						$blocks->blockBodyClose();	
					}
				}
			?>
		</td>
		<?php
			// Do they want either of these?
			if ($show_similar == "true" or $show_radio == "true"){
				echo '<td width="10%" valign="top">';
				if ($show_radio == "true"){
					$blocks->slickRadioBlock($node);
					$blocks->blockSpacer();
				}
				
				if ($show_similar == "true"){
					$blocks->slickSimilarArtistBlock($node,12); 
					$blocks->blockSpacer();
					$blocks->slickSimilarAlbumBlock($node,12); 
				}
				echo '</td>';
			}
		?>			
		</tr></table>		
		<?php
	}
?>
