<?php
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *        
	* JINZORA | Web-based Media Streamer   
	*
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a CMS site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL. 
	* 
	* Jinzora Author:
	* Ross Carlson: ross@jasbone.com 
	* http://www.jinzora.org
	* Documentation: http://www.jinzora.org/docs	
	* Support: http://www.jinzora.org/forum
	* Downloads: http://www.jinzora.org/downloads
	* License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* Contributors:
	* Please see http://www.jinzora.org/modules.php?op=modload&name=jz_whois&file=index
	*
	* Code Purpose: This page contains all the Genre/Artist display related functions
	* Created: 9.24.03 by Ross Carlson
	*
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	
	// This function displays all the Genres or Artists 
	function drawPage(&$node){
		global $media_dir, $skin, $hierarchy, $album_name_truncate, $web_root, $root_dir, 
		       $jz_MenuItemLeft, $jz_MenuSplit, $jz_MenuItemHover, $jz_MainItemHover, $jz_MenuItem,
			   $disable_random, $allow_download, $allow_send_email, $amg_search, $echocloud, $include_path, 
			   $img_play, $img_random_play, $this_page, $img_check, $img_check_none, $jzUSER, $img_play_dis, $img_random_play_dis,
 		       $show_sampler, $show_similar, $show_radio, $show_album_art, $days_for_new, $raw_img_new, $sort_by_year;			
							
		$display = &new jzDisplay();
		$blocks = &new jzBlocks();
		$fe = &new jzFrontend();
		if ($jzUSER->getSetting('stream')) {
			$playButtons = $display->playLink($node,$img_play,false,false,true). " ". 
						   $display->playLink($node,$img_random_play,false,false,true,true). " &nbsp; ";
		} else {
			$playButtons = $img_play_dis. $img_random_play_dis;
		}
		
		// Let's see if the theme is set or not, and if not set it to the default
                //if (isset($_SESSION['cur_theme'])){ $_SESSION['cur_theme'] = $skin; }
		

		$nodes = $node->getSubNodes("nodes");
		$tracks = $node->getSubNodes("tracks");

		?>
		<table width="100%" cellpadding="5">
			<tr>
				<td valign="top" width="10%" valign="top">
				<?php
		   if (sizeof($nodes) > 0) {
					$blocks->blockHeader(word("Albums"). ": ". $node->getName(). " (". $node->getSubNodeCount(). ")", $playButtons);
					$blocks->blockBodyOpen();
				?>
				<table width="100%" cellpadding="2" cellspacing="0" border="0">
					<tr>
						<td width="100%">
							<form name="albumForm" action="<?php echo urlize() .'"'; $display->embeddedFormHandler(); ?> method="POST">
				   			<input type="hidden" name="<?php echo jz_encode("action"); ?>" value="<?php echo jz_encode("mediaAction"); ?>">
                            <input type="hidden" name="<?php echo jz_encode("jz_path"); ?>" value="<?php echo htmlentities(jz_encode($node->getPath("String"))); ?>">
                            <input type="hidden" name="<?php echo jz_encode("jz_list_type"); ?>" value="<?php echo jz_encode("nodes"); ?>">
							<nobr>
							<?php
								// First let's sort this up
								if ($sort_by_year == "true"){
									sortElements($nodes,"year");
								} else {
									sortElements($nodes,"name");
								}
								foreach ($nodes as $child) {

									$display->playButton($child);
									$display->randomPlayButton($child);
									$display->downloadButton($child,false,false,true);
									$display->rateButton($child);
									echo '<input type="checkbox" name="jz_list[]" value="' . jz_encode($child->getPath("String")) . '">';
									echo '&nbsp;';
									// FYI, you can getYear for any media element. It's guessed from the tracks.
									$year = $child->getYear();
									$dispYear = "";
									if (!isNothing($year)){
										$dispYear = " (". $year. ")";
									}
									$display->link($child, $display->returnShortName($child->getName(),$album_name_truncate) . $dispYear, word("View album"). ": ". $child->getName() . $dispYear);
									// Now should we show new data?
									if ($days = $child->newSince($days_for_new)){
										echo ' <img src="'. $raw_img_new. '" border="0" '. $display->returnToolTip($days. " ". word("days ago"), word("New Since")). '>';
									}
									
									echo " &nbsp; ";
									$display->rating($child);
									// *******************************
									// Need to know how to return NEW information HERE
									// *******************************
									echo "<br>";
								}
								$blocks->blockSpacer();
								$blocks->slickPlaylistBar();
					  		?>
							</nobr>							
							
						</td>
					</tr>
				</table>
				<?php
				$blocks->blockBodyClose();
		   }
				// let's make sure we have a profile to show
				if ((($art = $node->getMainArt()) !== false or $node->getDescription() <> "") and $show_album_art <> "false") {

					$blocks->blockSpacer();
				
					$blocks->blockHeader(word("Artist Profile"). ": ". $node->getName(). " &nbsp;". $display->rating($node,true). " &nbsp; ", $playButtons);
					$blocks->blockBodyOpen();
					?>
					<table width="100%" cellpadding="2" cellspacing="0" border="0">
						<tr>
							<td width="100%">
								<?php									
									// Now let's show the art
									if (($art = $node->getMainArt("150x150")) !== false) {
										$display->image($art,$node->getName(),150,150,"limit",false,false,"left","5","5");
									}
									$blocks->description($node);
								?>
							</td>
						</tr>
					</table>
					<?php
						$blocks->blockBodyClose();
						}
					?>
				</td>
				<td width="80%" valign="top">
				<?php	
					// Now let's see if there are random tracks here
					if (count($tracks) <> 0){
						$blocks->blockHeader($node->getName(). " Tracks");
						$blocks->blockBodyOpen();		
						$blocks->trackTable($tracks, "album");
						$blocks->blockBodyClose();
						$blocks->blockSpacer();
					}
					
					// Do they want the sampler?
					if ($show_sampler == "true" && sizeof($nodes) > 0){
						// Now did they want to view all tracks or just the sampler?
						$viewall = false;
						if (isset($_GET['action'])){
							if ($_GET['action'] == "viewalltracks"){
								$viewall = true;
							}
						}					
						// Now let's display
						if (!$viewall){
							$blocks->displaySlickSampler($node);
						} else {
							$blocks->displaySlickAllTracks($node);
						}				
						
						// Now let's space
						$blocks->blockSpacer();
					}
					
					// Now let's show the album art
					$artarr = $node->getSubNodes("nodes",false,false,0,true);
					if ($show_album_art <> "false" && sizeof($artarr) > 0){
						$blocks->blockHeader(word("Album Art"));
						$blocks->blockBodyOpen();
						?>
						<table width="100%" cellpadding="2" cellspacing="0" border="0">
							<tr>
								<td width="100%">
									<?php
										echo '<table width="100%" cellpadding="5" cellspacing="0" border="0">';
										$c=0;
										foreach ($nodes as $child) {
											$year = $child->getYear();
											$dispYear = "";
											if ($year <> "-" and $year <> ""){
												$dispYear = " (". $year. ")";
											}
											// Now let's see if we should start a row
											if ($c==0){ echo '</tr><tr>'; }
												// Now let's display the data
												echo '<td width="50%" align="center"><center>';
												if (($art = $child->getMainArt("150x150")) == false) {								
													// TODO: Create the default image here IF they want it
													$art = "style/images/default.jpg";
												}
												echo '<nobr>';
												$display->link($child, $display->returnShortName($child->getName(),$album_name_truncate) . $dispYear, $child->getName() . $dispYear, "jz_artist_album");
												echo '</nobr>';
												echo '<br>';
												$display->link($child,$display->returnImage($art,$child->getName(),150,false,"fit"), $child->getName() . $dispYear);
												echo '<br><br></center></td>';
											// Now let's increment so we'll know where to make the table
											$c++;
											if ($c==2){$c=0;}
										}
										echo '</table>';
									?>
								</td>
							</tr>
						</table>
						<?php
						$blocks->blockBodyClose();	
					}
				?>			
				</td>
				<?php
					// Do they want either of these?
					if ($show_similar == "true" or $show_radio == "true"){
						?><td width="10%" valign="top"><?php
							if ($show_radio == "true"){
								$blocks->slickRadioBlock($node);
								$blocks->blockSpacer();
							}
							
							if ($show_similar == "true"){
								$blocks->slickSimilarArtistBlock($node,false,12);
							}
						?></td><?php
					}
				?>
			</tr>
		</table>
		<?php
	}
?>
