<?php
	/**
	* - JINZORA | Web-based Media Streamer -  
	* 
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a CMS site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL.
	* 
	* - Resources -
	* - Jinzora Author: Ross Carlson <ross@jasbone.com>
	* - Web: http://www.jinzora.org
	* - Documentation: http://www.jinzora.org/docs	
	* - Support: http://www.jinzora.org/forum
	* - Downloads: http://www.jinzora.org/downloads
	* - License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* - Contributors -
	* Please see http://www.jinzora.org/team.html
	* 
	* - Code Purpose -
	* Contains the Winamp httpQ plugin functions
	*
	* @since 2/9/05
	* @author Ross Carlson <ross@jinzora.org>
	*/
	
	/*
	
	NOTES FOR THIS JUKEBOX
	
	This Jukebox requires the following settings:
	
	server
	port
	password
	description
	type
	
	An example would be:
	$jbArr[0]['server'] = "localhost";
	$jbArr[0]['port'] = "4800";
	$jbArr[0]['password'] = "jinzora";
	$jbArr[0]['description'] = "Living Room";
	$jbArr[0]['type'] = "winamp"; // VERY IMPORTANT
	
	*/	
	
	
	/**
	* Returns the stats of the jukebox
	* 
	* @author Ross Carlson
	* @version 2/9/05
	* @since 2/9/05
	* @param return Returns a keyed array of the jukeboxe's abilities
	*/
	function retJBStats(){
		global $jbArr;
		
		return;
	}	
	
	/**
	* Returns a keyed array showing all the functions that this jukebox supports
	* 
	* @author Ross Carlson
	* @version 2/9/05
	* @since 2/9/05
	* @param return Returns a keyed array of the jukeboxe's abilities
	*/
	function returnJBAbilities(){
		
		$retArray['playbutton'] = true;
		$retArray['pausebutton'] = true;
		$retArray['stopbutton'] = true;
		$retArray['nextbutton'] = true;
		$retArray['prevbutton'] = true;
		$retArray['shufflebutton'] = true;
		$retArray['clearbutton'] = true;
		$retArray['status'] = true;
		$retArray['progress'] = true;
		$retArray['volume'] = true;
		$retArray['addtype'] = true;
		$retArray['nowplaying'] = true;
		$retArray['nexttrack'] = true;
		$retArray['fullplaylist'] = true;
		$retArray['refreshtime'] = true;
		$retArray['jump'] = true;
		$retArray['stats'] = false;
		
		return $retArray;
	}
	
	/**
	* Returns the connection status of the player true or false
	* 
	* @author Ross Carlson
	* @version 2/9/05
	* @since 2/9/05
	* @param return Returns true or false
	*/
	function playerConnect(){
		global $jbArr;
		
		$status = @file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/isplaying?p=". $jbArr[$_SESSION['jb_id']]['password']);		
		if ($status == ""){
			return false;
		} else {
			return true;
		}
	}
	
	/**
	* Returns Addon tools for MPD - namely refresh jukebox database
	* 
	* @author Ross Carlson
	* @version 2/9/05
	* @since 2/9/05
	* @param return Returns a link to refresh the MPD database
	*/
	function getAllAddOnTools(){
		return;
	}
	
	/**
	* Returns the currently playing tracks path so we can get the node
	* 
	* @author Ross Carlson
	* @version 2/9/05
	* @since 2/9/05
	* @param return Returns the currently playling track's path
	*/
	function getCurTrackPath(){
		global $jbArr;
		
		return file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/getplaylistfile?p=". $jbArr[$_SESSION['jb_id']]['password']. "&a=". getCurPlayingTrack());
	}
	
	/**
	* Returns the currently playing track number
	* 
	* @author Ross Carlson
	* @version 2/9/05
	* @since 2/9/05
	* @param return Returns the currently playling track number
	*/
	function getCurPlayingTrack(){
		global $jbArr;
		
		return file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/GETLISTPOS?p=". $jbArr[$_SESSION['jb_id']]['password']);
	}
	
	/**
	* Returns the currently playing playlist
	* 
	* @author Ross Carlson
	* @version 2/9/05
	* @since 2/9/05
	* @param return Returns the currently playling playlist
	*/
	function getCurPlaylist(){
		global $jbArr;
		
		return explode("<br>",str_replace("<br />","<br>",file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/GETPLAYLISTTITLE?p=". $jbArr[$_SESSION['jb_id']]['password']. "")));
	}

	/**
	* Passes a playlist to the jukebox player
	* 
	* @author Ross Carlson
	* @version 2/9/05
	* @since 2/9/05
	* @param $playlist The playlist that we are passing
	*/
	function playlist($playlist){
		global $include_path, $jbArr;
		
		// First we need to get the current playlist so we can figure out where to add
		$list = str_replace("\\","/",file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/getplaylistfile?p=". $jbArr[$_SESSION['jb_id']]['password']));
		$curList = explode("<br>",$list);
		
		// Let's get where we are in the current list
		$curTrack = getCurPlayingTrack();

		// Ok, now we need to figure out where to add the stuff
		if ($_SESSION['jb-addtype'] == "current"){
			// Ok, let's split our first playlist in 2 so we can add in the middle
			$begArr = array_slice($curList,0,$curTrack+1);
			$endArr = array_slice($curList,$curTrack+1);
		} else if ($_SESSION['jb-addtype'] == "begin"){
			$begArr = "";
			$endArr = array();
		} else if ($_SESSION['jb-addtype'] == "end"){
			$begArr = $curList;
			$endArr = array();
		}  else if ($_SESSION['jb-addtype'] == "replace") {
		  $begArr = array();
		  $endArr = array();
		}
		
		// Now let's clear the current list
		control("clear", false);
		
		// Now let's send the new playlist to the player
		for ($i=0; $i < count($begArr); $i++){
			// Now let's add this
			file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/playfile?p=". $jbArr[$_SESSION['jb_id']]['password']. "&a=". rawurlencode(str_replace("/","\\",$begArr[$i])));
		}		
		// Ok, Now let's add the new stuff
		$pArray = explode("\n",$playlist);
		for ($i=0; $i < count($pArray); $i++){
			// Now let's add this
			file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/playfile?p=". $jbArr[$_SESSION['jb_id']]['password']. "&a=". rawurlencode(str_replace("/","\\",$pArray[$i])));
		}
		// Now let's finish this out
		for ($i=0; $i < count($endArr); $i++){
			// Now let's add this
			file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/playfile?p=". $jbArr[$_SESSION['jb_id']]['password']. "&a=". rawurlencode(str_replace("/","\\",$endArr[$i])));
		}

		// Now that we've written the file we need to send it to the player
		file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/play?p=". $jbArr[$_SESSION['jb_id']]['password']);
		// Now we need to jump to the right track
		switch ($_SESSION['jb-addtype']){
			case "current":
				if ($curTrack == 0){$curTrack = -1;}
				$_POST['jbjumpto'] = $curTrack + 1;
			break;
			case "end":
				$_POST['jbjumpto'] = $curTrack;
			break;
			case "begin":
				$_POST['jbjumpto'] = 0;
			break;
		}
		control("jumpto",false);		
		?>
		<script>
			history.back();
		</script>
		<?php
		exit();
	}
		
	/**
	* Passes a command to the jukebox player
	* 
	* @author Ross Carlson
	* @version 2/9/05
	* @since 2/9/05
	* @param $command The command that we passed to the player
	* @param $goBack Should we go back after executing (default is true)
	*/
	function control($command, $goBack = true){
		global $jbArr;

		// Now let's execute the command
		switch ($command){
			case "play":
				$handle = fopen("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/play?p=". $jbArr[$_SESSION['jb_id']]['password']. "", "r");
			break;
			case "stop":
				$handle = fopen("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/stop?p=". $jbArr[$_SESSION['jb_id']]['password']. "", "r");
			break;
			case "pause":
				$handle = fopen("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/pause?p=". $jbArr[$_SESSION['jb_id']]['password']. "", "r");
			break;
			case "previous":
				$handle = fopen("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/prev?p=". $jbArr[$_SESSION['jb_id']]['password']. "", "r");
			break;
			case "next":
				$handle = fopen("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/next?p=". $jbArr[$_SESSION['jb_id']]['password']. "", "r");
			break;
			case "volume":
				// Now we have to set the value based on 0-255
				$vol = 255 * ($_POST['jbvol'] / 100);
				$handle = fopen("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/setvolume?p=". $jbArr[$_SESSION['jb_id']]['password']. "&a=". $vol, "r");			
				$_SESSION['jz_jbvol-'. $_SESSION['jb_id']] = $_POST['jbvol'];
			break;
			case "playwhere":
				// Ok, let's set where they are playing
				$_SESSION['jb_playwhere'] = $_POST['jbplaywhere'];
				// Now let's figure out it's ID
				for ($i=0; $i < count($jbArr); $i++){
					if ($jbArr[$i]['description'] == $_SESSION['jb_playwhere']){
						$_SESSION['jb_id'] = $i;
					}
				}
			break;
			case "jumpto":
				// We need to add 1 so we don't start at 0
				$pos = $_POST['jbjumpto'];
				file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/stop?p=". $jbArr[$_SESSION['jb_id']]['password']);
				file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/setplaylistpos?p=". $jbArr[$_SESSION['jb_id']]['password']. "&a=". $pos);
				usleep(1000);
				file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/play?p=". $jbArr[$_SESSION['jb_id']]['password']);
			break;
			case "clear":
				file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/stop?p=". $jbArr[$_SESSION['jb_id']]['password']);
				file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/delete?p=". $jbArr[$_SESSION['jb_id']]['password']);
				if ($goBack){
					?>
					<script>
						history.back();
					</script>
					<?php
				}
			break;
			case "random_play":
				// Ok, now we have to get the whole list, then shuffle it
				$list = file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/getplaylistfile?p=". $jbArr[$_SESSION['jb_id']]['password']);
				$lArray = explode("<br>",$list);
				// Now let's shuffle that
				shuffle($lArray);
				// Now we have to write it back out
				$pList = implode("\n",$lArray);
				// Now we have to play this, but first stop and clear the list
				file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/stop?p=". $jbArr[$_SESSION['jb_id']]['password']);
				file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/delete?p=". $jbArr[$_SESSION['jb_id']]['password']);
				playlist($pList);
			break;
			case "addwhere":
				$_SESSION['jb-addtype'] = $_POST['addplat'];
			break;
		}
	}
	
	/**
	* Returns the players current status
	* 
	* @author Ross Carlson
	* @version 2/9/05
	* @since 2/9/05
	*/
	function getStatus(){
		global $jbArr;
		
		$status = file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/isplaying?p=". $jbArr[$_SESSION['jb_id']]['password']);
		switch ($status){
			case "1":
				return "playing";
			break;
			case "0":
				return "stopped";
			break;
			case "3":
				return "paused";
			break;
		}
	}
	
	/**
	* Returns the current playing track
	* 
	* @author Ross Carlson
	* @version 2/9/05
	* @since 2/9/05
	* @return Returns the name of the current playing track
	*/
	function getCurTrackName(){
		global $jbArr;
		
		$track = file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/GETCURRENTTITLE?p=". $jbArr[$_SESSION['jb_id']]['password']);
		return substr($track,strpos($track,". ")+2);
	}
	
	/**
	* Returns how long is left in the current track (in seconds)
	* 
	* @author Ross Carlson
	* @version 2/9/05
	* @since 2/9/05
	* @return Returns the name of the current playing track
	*/
	function getCurTrackRemaining(){
		global $jbArr;
		
		$length = getCurTrackLength();
		$cur = getCurTrackLocation();
		return (($length - $cur) + 2);
	}
	
	/**
	* Gets the length of the current track
	* 
	* @author Ross Carlson
	* @version 2/9/05
	* @since 2/9/05
	* @param return returns the amount of time remaining in seconds
	*/
	function getCurTrackLength(){
		global $jbArr;
		
		return file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/getoutputtime?p=". $jbArr[$_SESSION['jb_id']]['password']. "&a=1");
	}
	
	/**
	* Returns how long is left in the current track (in seconds)
	* 
	* @author Ross Carlson
	* @version 2/9/05
	* @since 2/9/05
	* @return Returns the name of the current playing track
	*/
	function getCurTrackLocation(){
		global $jbArr;
		
		$cur = round((file_get_contents("http://". $jbArr[$_SESSION['jb_id']]['server']. ":". $jbArr[$_SESSION['jb_id']]['port']. "/getoutputtime?p=". $jbArr[$_SESSION['jb_id']]['password']. "&a=0") / 1000),0);
		return $cur;
	}
?>