<?php
	/**
	* - JINZORA | Web-based Media Streamer -  
	* 
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a CMS site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL.
	* 
	* - Resources -
	* - Jinzora Author: Ross Carlson <ross@jasbone.com>
	* - Web: http://www.jinzora.org
	* - Documentation: http://www.jinzora.org/docs	
	* - Support: http://www.jinzora.org/forum
	* - Downloads: http://www.jinzora.org/downloads
	* - License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* - Contributors -
	* Please see http://www.jinzora.org/team.html
	* 
	* - Code Purpose -
	* - This page handles requests to stream all types of files (images,media,zip)
	*
	* @since 01.11.05
	* @author Ross Carlson <ross@jinzora.org>
	* @author Ben Dodson <ben@jinzora.org>
	*/
	
	session_name('jinzora-session');
	session_start();
	
	// Let's set the error reporting level
	@error_reporting(E_ERROR);
	
	@include_once($include_path. 'settings.php');
	include_once($include_path. 'system.php');
	include_once($include_path. 'backend/backend.php');
	include_once($include_path. 'playlists/playlists.php');
	include_once($include_path. 'lib/general.lib.php');
	include_once($include_path. 'lib/jzcomp.lib.php');
	include_once($include_path. 'services/class.php');
	
	// Let's setup the services
	$jzSERVICES = new jzServices();
	$jzSERVICES->loadStandardServices();
	
	// Let's clean up the get vars
	$_GET = unurlize($_GET);
	
	// Let's get the user ID
	$uid = (isset($_GET['jz_user'])) ? $_GET['jz_user'] : false;
	if ($uid == ""){$uid = false;}
	
	// Let's setup the new user
	$jzUSER = new jzUser(false,$uid);
	
	// ACTIONS:				
	// play [for on-the-fly, basic playlist generation]
	//    -path
	//    -limit (default max_playlist_length)
	//    -type (specify the type of the path: track|node|playlist; default is to assume node.)
	//    -resample (NOT IMPLEMENTED)
	//
	// download [downloading tracks/nodes/playlist] (NOT IMPLEMENTED)
	//     -path
	//     -type (is this a track or a node? default: assume node.)
	//     -playlist (if this is set, ignore path)
	//
	// image [for displaying images; this makes it possible for images to not be in the webroot]
	//    -path (image path)
	//
	//    The following are for GD-based resizing, NOT HTML tag resizing:
	//    -width (resize the width)
	//    -height (resize the height)
	//    -constrain (constrained resize)
	if (!isset($_GET['action'])) $_GET['action'] = "play";
	
	switch ($_GET['action']) {
		// play a track:
		case "play":
			if (!(isset($_GET['jz_path']) || isset($_GET['file'])))
				exit();
				
			// send file directly, not with path:
			if (isset($_GET['file'])) {
				$resample = (isset($_GET['resample'])) ? $_GET['resample'] : false;
				sendMedia($_GET['file'],$_GET['fname'],$resample,getSkipBytes());
				exit();
			} else {	
				$be = new jzBackend();
				$el = &new jzMediaTrack($_GET['jz_path'],"id");
		
				if ($be->allowPlaycountIncrease($_GET['jz_user'],$el) !== false) {
					$el->increasePlayCount();
				}
				$meta = $el->getMeta();
				$title = $meta['artist'] . " - " . $el->getName();
				$resample = (isset($_GET['resample'])) ? $_GET['resample'] : false;

				if (isset($_GET['jz_user'])) {
					$be->setPlaying($_GET['jz_user'],$el);
					sendMedia($el->getFileName("host"),$title, $resample,getSkipBytes());
				} else {
					sendMedia($el->getFileName("host"),$title, $resample,getSkipBytes());
				}
			}
			exit();
		break;
		
		// download a collection of media:   
		case "image":
			showImage($_GET['jz_path']);
			exit();
		break;
	}
	
	function getSkipBytes() {
		if ($_SERVER['HTTP_RANGE'] != "") {
			// Skip over "bytes=" and remove the -
			return abs(substr($_SERVER['HTTP_RANGE'], 6));
		} else {
			return "";
		}
	}


?>
